#include <iostream.h>
#include <math.h>

class Integrator
{
public:
  double int_(double a, double b, unsigned points);
protected:
  virtual double fn(double) = 0;
};

double Integrator::int_(double a, double b, unsigned points)
{
  double sum = 0.0;
  unsigned i;
  cout << "Stack of integrate: " << (void *)&sum << endl;
  for (i = 0; i < points; i++)
    sum += fn(a + i * (b - a) / points);
  return sum / (b - a);
}

class MyIntegrator: public Integrator
{
  virtual double fn(double);
};

double MyIntegrator::fn(double x)
{
  return 1.0 / (1.0 + x);
}

double integrate(double a, double b, unsigned points)
{
  return MyIntegrator().int_(a, b, points);
}
