#include <math.h>
#include <iostream.h>

template<double (*f)(double)>
double int_(double a, double b, unsigned points)
{
  double sum = 0.0;
  cout << "Stack of integrate: " << (void *)&sum << endl;
  unsigned i;
  for (i = 0; i < points; i++)
    sum += (*f)(a + i * (b - a) / points);
  return sum / (b - a);
}

inline double fn(double x)
{
  return 1.0 / (1.0 + x);
}

double integrate(double a, double b, unsigned points)
{
  return int_<fn>(a, b, points);
}
